package me.icymint.libra.sage.core.dialect.query;

import me.icymint.libra.sage.model.SqlTable;
import me.icymint.libra.sage.model.SqlVar;

public class TableQueryVar extends QueryVar {

	private SqlTable t;
	private SqlInnerFunction sif;

	public TableQueryVar(SqlTable t, SqlInnerFunction sif) {
		this.t = t;
		if (sif == null)
			sif = SqlInnerFunction.NULL;
		this.sif = sif;
	}

	@Override
	public SqlTable getTable() {
		return t;
	}

	@Override
	public String getText() {
		if (sif.equals(SqlInnerFunction.NULL)) {
			return "*";
		} else {
			return sif.name() + "(*)";
		}
	}

	@Override
	public SqlVar getVar() {
		return null;
	}

}
