package me.icymint.libra.sage.core.result;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.LinkedList;
import java.util.List;

/**
 * 提取一组抽象的List结果。
 * 
 * @author Daniel
 * @datetime 2012-11-12上午11:01:33
 * 
 * @param <T>
 */
public abstract class ListResultHandler<T> extends
		AbstractResultHandler<List<T>> {

	protected ListResultHandler(int offset) {
		super(offset);
	}

	@Override
	public List<T> handle(ResultSet rs) throws SQLException {
		List<T> ts = new LinkedList<T>();
		int i = 1;
		while (rs.next()) {
			if (i >= this.getOffset()) {
				T e = this.handle(rs, i);
				if (e != null)
					ts.add(e);
			}
			i++;
		}
		return ts;
	}

	/**
	 * 这里可以根据特殊情况进行构造类T。
	 * 
	 * @param rs
	 * @param collumnIndex
	 * @throws SQLException
	 */
	public abstract T handle(ResultSet rs, int collumnIndex)
			throws SQLException;
}
