package me.icymint.libra.sage.model.object;

import me.icymint.libra.sage.model.SqlInfo;

/**
 * Sql对象基础信息。
 * 
 * @author Daniel
 * @datetime 2012-11-12上午11:28:35
 * 
 */
public interface SqlObject {
	/**
	 * Sql对象的Id号，其对所有Sql对象都必须唯一。
	 */
	String getId();

	/**
	 * Sql对象的名称。其对同类Sql对象唯一。
	 */
	String getName();

	/**
	 * Sql对象的前缀。
	 */
	String getPrefix();

	/**
	 * 获取该对象所对应的Sql信息。
	 */
	SqlInfo getSqlInfo();

	/**
	 * Sql对象是否被屏蔽。
	 */
	boolean isMask();

	/**
	 * Sql对象的实际名称。
	 */
	@Override
	String toString();
}
