package me.icymint.libra.sage.model.object;

import me.icymint.libra.sage.model.SqlInfo;
import me.icymint.libra.sage.model.SqlTable;
import me.icymint.libra.sage.model.SqlVar;
import me.icymint.libra.sage.model.operator.ManagerObjects;
import me.icymint.libra.sage.model.operator.SQLExistsException;
import me.icymint.libra.sage.model.operator.SQLNotExistsException;
import me.icymint.libra.sage.model.operator.TableManager;

public abstract class TableManagerObject extends VarManagerObject implements
		TableManager {

	private final ManagerObjects<SqlTable> mo;

	protected TableManagerObject(SqlInfo si, String prefix, String name,
			boolean isMask, SqlVar[] sv, SqlTable... st) {
		super(si, prefix, name, isMask, sv);
		mo = new ManagerObjects<SqlTable>(st, SqlTable.class);
	}

	@Override
	public void addTable(SqlTable t) throws SQLExistsException {
		mo.add(t);
	}

	@Override
	public void delTable(SqlTable t) {
		mo.del(t);
	}

	@Override
	public SqlTable getTable(int ind) throws SQLNotExistsException {
		return mo.get(ind);
	}

	@Override
	public SqlTable getTable(String name) throws SQLNotExistsException {
		return mo.get(name);
	}

	@Override
	public int getTableIndex(String name) throws SQLNotExistsException {
		return mo.getIndexOf(name);
	}

	@Override
	public SqlTable[] getTables() {
		return mo.getAll();
	}

	@Override
	public int getTableSize() {
		return mo.getSize();
	}

}
